CHANGES IN VERSION 1.13.6
-------------------------

BUG FIXES

  - droplevels suggestion for sample-data https://github.com/joey711/phyloseq/pull/476

  - DESeq2 migrated to suggests https://github.com/joey711/phyloseq/pull/533
  
  - `extend_metagenomeSeq` functionality https://github.com/joey711/phyloseq/pull/533
  
  - bugs related to previous version distance uptick, mostly in tests and vignette

CHANGES IN VERSION 1.13.5
-------------------------

USER-VISIBLE CHANGES

  - Help avoid cryptic errors due to name collision of `distance` with external loaded packages by making `distance` a formal S4 method in phyloseq.
  - Improve documentation of `distance` function and the downstream procedures on which it depends
  - Migrate the list of supported methods to a documented, exported list object, called `distanceMethodList`.
  - Improved distance unit tests with detailed checks that dispatch works and gives exactly expected distance matrices for all methods defined in distanceMethodList.
  - Improved JSD doc, performance, code, deprecated unnecessary `parallel` argument in JSD


CHANGES IN VERSION 1.13.4
-------------------------

BUG FIXES

  - `psmelt` bug if user has also loaded the original "reshape" package, due to name collision on the function called `melt`. `psmelt` now explicitly calls `reshape2::melt` to avoid confusion. https://github.com/joey711/phyloseq/pull/489
  
  - Fix following note... There are ::: calls to the package's namespace in its code. A package almost never needs to use ::: for its own objects: ‘JSD.pair’

CHANGES IN VERSION 1.11.3
-------------------------

BUG FIXES

  - plot_heatmap bug when PCoA/MDS used as ordination method for axis ordering. This solves issue 420 https://github.com/joey711/phyloseq/issues/420

CHANGES IN VERSION 1.11.2
-------------------------

USER-VISIBLE CHANGES

  - `plot_heatmap` replaces `geom_tile` with `geom_raster`. This should afford a substantial speed improvement during rendering of heatmaps, according to ggplot2 documentation. This also solves Issue 401 https://github.com/joey711/phyloseq/issues/401

CHANGES IN VERSION 1.11.1
-------------------------

BUG FIXES

  - plot_heatmap y-axis

CHANGES IN VERSION 1.9.15
-------------------------

BUG FIXES

	- `phyloseq_to_deseq2` was adding an unnecessary pseudocount of `1` to the count matrix. No longer.

	- Originally described at https://github.com/joey711/phyloseq/issues/387

CHANGES IN VERSION 1.9.14
-------------------------

BUG FIXES

	- `distance` erroneously transformed Rao distance results for method DPCoA. Now Fixed.

	- Originally described at https://github.com/joey711/phyloseq/issues/390

CHANGES IN VERSION 1.9.13
-------------------------

USER-VISIBLE CHANGES

	- `distance` function now supports "wunifrac" option, for `UniFrac(..., weighted=TRUE)`

	- `distance` function regexpr-matching for range of variants for weighted-UniFrac, unweighted-UniFrac method option

	- `distance` function regexpr-matching for `type` argument range of alternatives

	- Proposed in https://github.com/joey711/phyloseq/pull/384

CHANGES IN VERSION 1.9.12
-------------------------

BUG FIXES

	- `psmelt` function now properly handles single-OTU data

	- Related to https://github.com/joey711/phyloseq/issues/338

	- Builds on https://github.com/joey711/phyloseq/pull/373

CHANGES IN VERSION 1.9.11
-------------------------

USER-VISIBLE CHANGES

	- More robust `plot_ordination` behavior with clearer warning/error messages.

	- Coordinates automatically checked/assigned to OTU or samples

	- Attempt to calculate OTU or sample weighted-average coordinates via `vegan::wascores`, if-needed

	- Species weighted-average via `vegan::wascores` supported now in phyloseq::scores.pcoa

	- Related to https://github.com/joey711/phyloseq/pull/364

CHANGES IN VERSION 1.9.10
-------------------------

USER-VISIBLE CHANGES

	- Massive speed/memory improvement for UniFrac calculations (via `UniFrac` or `distance`)

	- Added unit-tests for the correctness of UniFrac results (no bugs detected. results from pycogent)

	- Moved all unit tests to tests/testthat as recommended by CRAN maintainers and testthat doc

CHANGES IN VERSION 1.9.9
-------------------------

USER-VISIBLE CHANGES

	- `plot_net` faster, more-flexible network plot with improved defaults

	- https://github.com/joey711/phyloseq/pull/353

CHANGES IN VERSION 1.9.8
-------------------------

USER-VISIBLE CHANGES

	- `mt` includes other corrections, FDR by default.

	- Resolves [Issue 59](https://github.com/joey711/phyloseq/issues/59)

CHANGES IN VERSION 1.9.7
-------------------------

BUG FIXES

	- Now requires ggplot2 version 1.0.0

	- Fixes bug in which ggplot 1.0 breaks in a phyloseq vignette 

	- Resolves [Issue 347](https://github.com/joey711/phyloseq/issues/347) 

CHANGES IN VERSION 1.9.6
-------------------------

USER-VISIBLE CHANGES

	- New `sortby` argument in `plot_richness` function.

	- Sort discrete x by one or more alpha-diversity measures

	- Solves [Issue 342](https://github.com/joey711/phyloseq/issues/342)

	- Resolves/merges [Pull 343](https://github.com/joey711/phyloseq/pull/343) 

CHANGES IN VERSION 1.9.5
-------------------------

USER-VISIBLE CHANGES

	- `microbio_me_qiime` function now handles string study number for first argument.

		This is in addition to numeric study number, already supported.

CHANGES IN VERSION 1.9.4
-------------------------

BUG FIXES

	- `rarefy_even_depth()` function no longer enforces an orientation.

	- It used to always coerce to OTU-by-sample orientation.

	- Solves Issue 320 https://github.com/joey711/phyloseq/issues/320

CHANGES IN VERSION 1.9.3
-------------------------

USER-VISIBLE CHANGES

	- Massive Revision to plot_tree()

	- `plot_tree` now uses the `psmelt` function

		- All covariates are available for aesthetic mapping.

	- `plot_tree` substantial speed improvement

		- Uses native ape-package C code for tree computation

		- Efficient `data.table` consolidated graphic data passed to ggplot2

		- Additional arguments: `treetheme` and `justify`

	- `tree_layout` - new, user-accessible function

		- for building alternative trees from phyloseq data.

	- Foundation for solving Issue 313 and Issue 331

		- https://github.com/joey711/phyloseq/issues/313

		- https://github.com/joey711/phyloseq/issues/331

CHANGES IN VERSION 1.9.2
-------------------------

BUG FIXES

	- Large files cause import_usearch_uc() to have error.
		Error in paste0(readLines(ucfile), collapse = "\n") : result would exceed 2^31-1 bytes

	- Solves Issue 327: https://github.com/joey711/phyloseq/issues/327

CHANGES IN VERSION 1.9.1
-------------------------

BUG FIXES

	- Bug in `psmelt` causing unnecessary error for phyloseq datasets with empty components.

	- Solves Issue 319: https://github.com/joey711/phyloseq/issues/319

CHANGES IN VERSION 1.7.24
-------------------------

USER-VISIBLE CHANGES

	- Added support for [Partial] Constrained Analysis of Principal Coordinates (CAP).

		- A supported/documented option in `ordinate`, supported by `plot_ordination`.

		- This solves [Issue 312](https://github.com/joey711/phyloseq/issues/312).

	- The `ordinate` function now takes an explicit `formula` argument. 

		- This facilitates reliable contrained ordination calls for:

			- CAP (this commit)

			- RDA (partial redundancy analysis)

			- CCA (constrained correspondence analysis)

CHANGES IN VERSION 1.7.23
-------------------------

USER-VISIBLE CHANGES

	- Refactor `plot_ordination` to be more stable, error less and give informative warnings.

	- Expect no critical API changes. Some errors now informative warnings with useful auto-changes to parameters.

	- The `type='biplot'` option no longer hard-specifies a discrete color scale. Available default pallette should work.

	- For `type='biplot'`, the non-variable (Taxa or Sample) label will always appear first in a discrete legend.

CHANGES IN VERSION 1.7.22
-------------------------

USER-VISIBLE CHANGES

	- Revised psmelt to automatically modify data column-name conflicts, with warning

	- Udpated `psmelt` doc to formally notify users of these potential conflicts.

	- This solves Issue 307: https://github.com/joey711/phyloseq/issues/307

CHANGES IN VERSION 1.7.21
-------------------------

USER-VISIBLE CHANGES

	- Updated `import_qiime` doc to emphasize it is intended for legacy QIIME files.

	- Much faster and mem-efficient import of legacy QIIME and usearch files.

	- Uses data.table syntax to better manage import of large files.

	- Entire HMPv35 now imports in about 1 minute, low risk of mem-swap.

	- Added dependency to data.table

CHANGES IN VERSION 1.7.20
-------------------------

USER-VISIBLE CHANGES

	- No user-visible changes. All future compatibility changes.

BUG FIXES

	- Unit test changes to work with upcoming R release and new testthat version. 

CHANGES IN VERSION 1.7.19
-------------------------

USER-VISIBLE CHANGES

	- Documentation revisions. Faster examples, updated links.

CHANGES IN VERSION 1.7.18
-------------------------

USER-VISIBLE CHANGES

	- Fix minor bug that prohibited parallel execution of weighted UniFrac

CHANGES IN VERSION 1.7.17
-------------------------

USER-VISIBLE CHANGES

	- Added `import_usearch_uc`

		Added first-time support for usearch “.uc” style output table.
			Addresses Issue 286, importing from UPARSE.
			https://github.com/joey711/phyloseq/issues/286
			Further feedback on performance, use-cases, should be posted there. 

CHANGES IN VERSION 1.7.16
-------------------------

USER-VISIBLE CHANGES

	- Fixed minor bug affecting legend-order in `plot_network`
		Issue 288, 
		https://github.com/joey711/phyloseq/issues/288

CHANGES IN VERSION 1.7.15
-------------------------

USER-VISIBLE CHANGES

	- `tip_glom` now uses standard R clustering tools, and takes their arguments
		documentation and tests updated to reflect the change
		much simpler, faster

	- `merge_taxa` now uses abundance to determine the achetype by default. Previously arbitrary.

CHANGES IN VERSION 1.7.14
-------------------------

USER-VISIBLE CHANGES

	- Minor change in mixture model vignette, revised graphic

CHANGES IN VERSION 1.7.13
-------------------------

USER-VISIBLE CHANGES

	- Deprecated originalUniFrac() internal function
		old (original) unifrac algorithm no longer supported. 
		Addresses Issue 66:
		https://github.com/joey711/phyloseq/issues/66

CHANGES IN VERSION 1.7.12
-------------------------

USER-VISIBLE CHANGES

	- Formal deprecation of functions using .Deprecated
		Issue 269, 
		https://github.com/joey711/phyloseq/issues/269

	- Fixed bug in interface with vegan::fisher.alpha(..., se=TRUE). 
		vegan doc states that this returns a data.frame, 
		but a data.frame is not returned in vegan version 1.7.10.
		phyloseq no checks output dimensions before processing in `estimate_richness`

	- Replaced deprecated functions in tests and documentation.

CHANGES IN VERSION 1.7.11
-------------------------

USER-VISIBLE CHANGES

	- Adds warning in make_network() and error in plot_network if empty graph encountered
		Issue 275, check/warning for empty igraph objects
		https://github.com/joey711/phyloseq/issues/275
	
	- rarefy_even_depth() messages changed from cat() to messages(), and optional verbose argument added
		https://github.com/joey711/phyloseq/issues/263

CHANGES IN VERSION 1.7.10
-------------------------

USER-VISIBLE CHANGES

	- Fixes build-error originating from change in ade4 NAMESPACE in version 1.6.2
	
	- Change minimum ade4 version to 1.6.2
	
	- Uncommented examples now included in documentation for DPCoA function

CHANGES IN VERSION 1.7.9
-------------------------

USER-VISIBLE CHANGES

	- Fixed typo-derived bug in new vignette.

	- These changes allow user to build from source without error.

CHANGES IN VERSION 1.7.8
-------------------------

USER-VISIBLE CHANGES

	- Package dependencies reduced/clarified:
		https://github.com/joey711/phyloseq/issues/259
		Should reduce chances for collisions with other packages, and related issues.
		Removed any dependencies on the picante package.

	- Replaced picante::node.age() with a faster implementation, node_ages()
		Appears to be 3 times faster.
		Speeds up UniFrac() and tip_glom() calculations.

CHANGES IN VERSION 1.7.7
-------------------------

USER-VISIBLE CHANGES

	- Tree fixes:
		https://github.com/joey711/phyloseq/issues/235
		https://github.com/joey711/phyloseq/issues/255

	- If a tree has NA branch-length values, they are automatically set to 0.
		This occurs within both phyloseq(), and read_tree().

	- UniFrac calculations require a rooted tree. While a rooted tree is
		not required to be part of a phyloseq object, it is a helpful
		default behavior to select a random root when UniFrac is called
		and the tree is unrooted, flashing a notice to the user.
	
	- Precise import from ape-package, rather than full-import. 
		Smaller chance for collisions.
		Precisely-defined dependencies listed in NAMESPACE

	- As a result of the previous, phyloseq defines a placeholder "phylo" class,
		extended from "list". This seems to match the class
		from a full import of ape, and is necessary since ape does not
		export the "phylo" class.

CHANGES IN VERSION 1.7.6
-------------------------

USER-VISIBLE CHANGES

	- Merged branches 1.7.4 and 1.7.5

CHANGES IN VERSION 1.7.5
-------------------------

NEW FEATURES

	- User-specified axis ordering to plot_heatmap()

	- User-specified axis edges to plot_heatmap()

	- This addresses:
	  [Issue 237](https://github.com/joey711/phyloseq/issues/237)
	  [Issue 230](https://github.com/joey711/phyloseq/issues/230)

USER-VISIBLE CHANGES
	
	- New arguments to plot_heatmap():
	  `taxa.order`, `sample.order`, `first.sample`, `first.taxa`

CHANGES IN VERSION 1.7.4
-------------------------

NEW FEATURES

	- import_mothur now handles more formats
	
	- Added documentation to discourage .group/.list formats

CHANGES IN VERSION 1.7.3
-------------------------

NEW FEATURES

	- Added phyloseq_to_deseq2() wrapper function and examples for computing
	  multiple OTU tests using Negative Binomial model and GLM (DESeq2).

USER-VISIBLE CHANGES

	- Also added new .Rmd vignette for using DESeq, with colorectal carcinoma data

CHANGES IN VERSION 1.7.2
-------------------------

USER-VISIBLE CHANGES

	- Reformat NEWS (this) file.

CHANGES IN VERSION 1.7.1
-------------------------

USER-VISIBLE CHANGES

	- Rmd/HTML-based vignettes. No more Rnw/Sweave/PDF

	- Updated installer

CHANGES IN VERSION 1.5.23 
-------------------------

USER-VISIBLE CHANGES

	- Update dependency from igraph0 to igraph

	- Requested by CRAN

	- igraph0 is being deprecated, removed from CRAN

	- igraph is actively updated/maintained. igraph0 isn't / soon won't be.

	- The load bug that I could find from re-running the tutorial in the new dependency
	  had to do with accessing the vertex names. The appropriate function is:
	  `get.vertex.attribute`
	  which was not used previous, but is now imported and used in this version of phyloseq.

	- This also closes [Issue 247](https://github.com/joey711/phyloseq/issues/247)

CHANGES IN VERSION 1.5.22
-------------------------

USER-VISIBLE CHANGES

	- Fix minor bug in `import_mothur`

	- Bug occurs only when sample names are pure integers. One line fix.

	- This addresses [Issue 242](https://github.com/joey711/phyloseq/issues/242) 

CHANGES IN VERSION 1.5.21 
-------------------------

USER-VISIBLE CHANGES

	- `plot_richness` / `estimate_richness` updates

	- Additional alpha-diversity measures added to both functions.
	
	- New argument, `measures`, added to both functions, allows user to 
	   specify which measures to calculate/display.

	- Also added unit tests for both functions, absent in prior versions


CHANGES IN VERSION 1.5.20 
-------------------------

USER-VISIBLE CHANGES

	- Bugfixes, `read_tree_greengenes`, and a `replace` optional parameter to rarefy_even_depth()

	- read_tree_greengenes() is a new function created specifically to address the problem
	   created when the greengenes consortium chose to publish their official release trees
	   with semicolon-delimited node labels, even though semicolons are also a special newick character.
	   The semicolons only appear when a node has more than one taxonomic rank assigned to it,
	   which is rare in the smaller (lower OTU similarity threshold) trees, but a big problem
	   in all the most commonly used trees, e.g. 97% tree. 
	   The hard part was identifying the precise cause of the problem. Now that it is precisely known,
	   the offending delimiters are temporarily replaced so that the standard parser `read.tree`
	   can create the phylo object, then they are reinstated. 
	   Unit tests have been added to check that this works properly on a GreenGenes release tree
	   that otherwise breaks `read.tree`.
	   This also solves 224
	   https://github.com/joey711/phyloseq/issues/224

	- Fixed a bug in which the highest taxonomic rank fails in `tax_glom`
	  This was a bug resulting from the automatic coercion of single-column
	  matrix subsetting to a vector. Simply changing the relevant line
	  of code in `tax_glom` such that [, , drop=FALSE],
	  solve this issue, Issue 223
	  https://github.com/joey711/phyloseq/issues/223
	  Unit tests have been added that should catch this in the future.

	- rarefy_even_depth() new option to sample without replacement.
	  Two implications to consider are that
	  (1) sampling with replacement is faster and more memory efficient
	  as currently implemented;
	  (2) sampling with replacement means that there is a chance that the
	  number of reads for a given OTU in a given sample could be larger
	  than the original count value. This is in contrast to sampling without replacement
	  where the original count value is the maximum possible.
	  Prior to this phyloseq version,
	  this `replace` parameter did not exist and sampling with replacement was the only
	  random subsampling implemented in the `rarefy_even_depth` function.
	  This prior behavior was selected for computational efficiency, but
	  differs from the behavior of analogous functions in related packages
	  (e.g. rarefying in QIIME).

CHANGES IN VERSION 1.5.19 
-------------------------

USER-VISIBLE CHANGES

	- add gap statistic support for ordination results

	- gapstat_ord() - wrapper function for cluster::clusGap for ordination methods

	- plot_clusgap() - wrapper function for plotting gap statistic results from clusGap()

	- Full examples on the soilrep dataset for gap statistic.

	- Fix bug in eigenvalue proportions for axes other 
	  than the first two in ordination plots.

CHANGES IN VERSION 1.5.17 
-------------------------

USER-VISIBLE CHANGES

	- replace URL with new phyloseq article
		http://dx.plos.org/10.1371/journal.pone.0061217

CHANGES IN VERSION 1.5.16 
-------------------------

USER-VISIBLE CHANGES

	- rarefy_even_depth improvements
	  User-side convenience upgrades to rarefy_even_depth() behavior.

	- More user feedback about process.

	- New argument for setting RNG seed, with a default value (reproducible by default).

	- Reports the RNG seed being used for random subsampling, encouraging users to record this for 		  reproducibility.
	
	- Trims empty samples/OTUs automatically, and reports this to standard out.


CHANGES IN VERSION 1.5.13-15 - build improvements, changed dependencies
-------------------------

USER-VISIBLE CHANGES

	- Shifted RJSONIO dependency to the new "biom" package in CRAN

CHANGES IN VERSION 1.5.11-12 - 
-------------------------

USER-VISIBLE CHANGES

	- major feature: interface to microbio.me/qiime data repo

	- Now possible to directly download, unpack, import multi-component data
		into standard phyloseq form in R using a single command using the new
		microbio_me_qiime()
		command. Supports the following input styles:

	- full URL to the precise study on the server,

	- a local path to the same compressed raw data file on your system if you 
	  already downloaded

	- Just the study number on the microbio.me/qiime repo. For example:
	  microbio_me_qiime(524) will download and import the "smokers" dataset.

	- See the following tutorial for more details:
		http://joey711.github.io/phyloseq/download-microbio.me.html

CHANGES IN VERSION 1.5.9 - minor bugfix
-------------------------

USER-VISIBLE CHANGES

	- Bugfix for psmelt()/plotting when entire columns in tax_table are empty

CHANGES IN VERSION 1.5.8 - update reshape dependency to reshape2
-------------------------

USER-VISIBLE CHANGES

	- This satisfies [issue 134](https://github.com/joey711/phyloseq/issues/134)

CHANGES IN VERSION 1.5.6-.7 - plot_ordination()
-------------------------

USER-VISIBLE CHANGES

	- plot_ordination() now includes percent variability on axis labels, if possible

CHANGES IN VERSION 1.5.5 
-------------------------

USER-VISIBLE CHANGES

	- Update citation info for latest per-reviewed phyloseq article

	- http://dx.plos.org/10.1371/journal.pone.0061217

CHANGES IN VERSION 1.5.4 - Add taxonomic classification data to mt() output, if available
-------------------------

USER-VISIBLE CHANGES

	- This completes a feature request in [Issue 179](https://github.com/joey711/phyloseq/issues/179)

CHANGES IN VERSION 1.5.3 
-------------------------

USER-VISIBLE CHANGES

	- bug fix in plot_heatmap labels derived from ggplot2 change

	- This solves a bug described in [Issue 192](https://github.com/joey711/phyloseq/issues/192)

CHANGES IN VERSION 1.5.2 
-------------------------

USER-VISIBLE CHANGES

	- bug fix pass extra args to `transform_sample_counts`

CHANGES IN VERSION 1.5.0 
-------------------------

USER-VISIBLE CHANGES

	- Level up to R version 3.0.0

CHANGES IN VERSION 1.3.23 
-------------------------

USER-VISIBLE CHANGES

	- bug fix for transform_sample_counts

	- Only appears to affect OTU tables in the "taxa are columns" orientation.
		It is the result of a surprising behavior of the apply() function,
		which in this circumstance transposes the table.

	- This solves a bug described in [Issue 186](https://github.com/joey711/phyloseq/issues/186)

CHANGES IN VERSION 1.3.22 
-------------------------

USER-VISIBLE CHANGES

	- additional tests for prun_*() and phyloseq() functions

	- Before releasing v1.3.21 on GitHub:master some gaps in re-order checking were noticed. 
		These are now caught by new unit tests and phyloseq/prune/etc have been further revised to
 		ensure that properly-ordered OTUs are not disordered during a pruning step.

CHANGES IN VERSION 1.3.21 
-------------------------

USER-VISIBLE CHANGES

	- accessor efficiency
	
	- For instance, ntaxa() and taxa_names() are very slow on large dataset
		Some of the highly inefficient approaches are now replaced. 
		The strategy is described further in [Issue 183](https://github.com/joey711/phyloseq/issues/183)


CHANGES IN VERSION 1.3.20 
-------------------------

USER-VISIBLE CHANGES

	- reference sequence class update.

	- formally define the new version of phyloseq-class with refseq slot included

	- new/augmented accessors: taxa_names, ntaxa, refseq

	- phyloseq() constructor now supports XStringSet components

	- reconcile_species internal function removed/replaced

	- reconcile_species removed from constructor and package. internal, so no need to deprecate.
	
	- check the component slot list provided by the "splat" infrastructure

	- prune_taxa

	- Rebuild current example data.

	- print/show methods. 

	- subset_taxa
	
	- add refseq (XStringSet) object argument to import functions. import_qiime, import_biom

	- merge_phyloseq: works with refseq data

	- Add merge_taxa method for XStringSet objects

	- Include reference sequences in example datasets

	- prune_* / reconcile_* / intersect_* . 
		add intersect_samples() function, model after new version of intersect_species()
		rename intersect_species to intersect_taxa()	
		rm/replace reconcile_* functions with prune_*(intersect_*(), ps).
		These changes make simpler / DRYer code. Easier to extend.

	- DRY (and hopefully speed) improvements to merge_taxa(). 
		Additional speed improvements may be possible for tip_glom, tax_glom in later revisions

CHANGES IN VERSION 1.3.14
-------------------------

USER-VISIBLE CHANGES

	- Shortened/replaced examples in the longest-running doc examples.
	  This substantially reduces the time it takes to run package checks.

	- Focused on worst offenders

	- Created a new online tutorial for `subset_ord_plot`. 
	  Linked to it from `plot_ordination`

	- `plot_taxa_bar` moved to deprecated function file where it belongs,
	   and examples completely removed from doc.


CHANGES IN VERSION 1.3.13
-------------------------

USER-VISIBLE CHANGES

	- Fixed unofficial warning from missing (unregistered) classes 
	  of ordination objects. Stems from the internal get_eigenvalue
  	  being defined as S4 generic instead of S3.
	  Solves the following logged issue:
	  https://github.com/joey711/phyloseq/issues/166

	- Name of get_eigenvalue generic replaced with extract_eigenvalue,
	  in addition to re-defining as S3 generic. 

	- Fixed ggplot2 warning from over-specified "bins" in the
	  plot_scree bar plot. Changed to stat="identity", solves problem

	- Fixed warning when eigenvalues get (slightly) negative. They
	  are now set to 0.0 for the purposes of plotting in plot_scree.

CHANGES IN VERSION 1.3.12
-------------------------

USER-VISIBLE CHANGES

	- Fixed a parsing issue for some QIIME-produced .biom files
	  that had leading space characters. Issue further described at
	  https://github.com/joey711/phyloseq/issues/171
	  Fixed such that any number of leading/lagging space characters
	  are removed from taxonomic classification entries

	- Fixed build issue on some windows machines derived from problem
	  with figure files having colons in the filename.

CHANGES IN VERSION 1.3.11
-------------------------

USER-VISIBLE CHANGES

	- Added tree option for import_biom() importer so that users can avoid
	  using merge_phyloseq() if their files are otherwise standard vanilla

	- Address Issue 169 and 167
	  https://github.com/joey711/phyloseq/issues/169
	  https://github.com/joey711/phyloseq/issues/167

CHANGES IN VERSION 1.3.10
-------------------------

USER-VISIBLE CHANGES

	- Added support for Shannon/Simpson alpha-diversity indices in plot_richness
	  https://github.com/joey711/phyloseq/issues/164

	- All sample_data now embedded in plot_richness output graphic, in case want 
	  to use other covariates in additional layers not originally specified.
	  For instance, if you wanted to include geom_text(label=addLayer1).
	  See plot_richness online tutorial.

CHANGES IN VERSION 1.3.9
-------------------------

USER-VISIBLE CHANGES

	- Added ability to add node labels, bootstrap values to tree graphics
	  generated by plot_tree.

	- The labeling itself is opened-up as a user-provided function to facilitate
	  custom node-labeling needs (including symbols and other ggplot2 geoms)

	- Commonly-needed functions are provided as newly-documented exported 
	  functions in the package:
		nodeplotdefault - adds whatever is in the node label to the graphic
		nodeplotboot - Adds the labels as bootstrap values, coercing/rounding as needed
		nodeplotblank - Ensures that node labels are not added.

	- These new functions can be used to give valid arguments to the new
	  `nodelabf` argument in plot_tree().

	- Some other re-organization to plot_tree to show more code in 
	  the main plot_tree function.

CHANGES IN VERSION 1.3.8
-------------------------

USER-VISIBLE CHANGES

	- Fix bug in plot_tree graphic if sample names start with a number

	- This fixes https://github.com/joey711/phyloseq/issues/149

	- Also added fill argument to default aesthetic map definition, useful if fillable shapes defined in subsequent layers

CHANGES IN VERSION 1.3.7
-------------------------

USER-VISIBLE CHANGES

	- Revisions to plot_tree to improve formatting, organization

	- "ladderize" contributed by Gregory Jordan

	- Color scale option removed from original pull request
	
	- already supported as core ggplot2 functionality through layering

	- Added links and roxygen2-header revisions for proper doc formatting

	- Fixed bug in which alternative size-variables still labeled as "abundance" in legend.

CHANGES IN VERSION 1.3.6
-------------------------

USER-VISIBLE CHANGES

	- Updated basics vignette

CHANGES IN VERSION 1.3.5
-------------------------

USER-VISIBLE CHANGES

	- Updated README.md to point to phyloseq home page (instead of redundant display of content). 
	
	- Also added README.html

CHANGES IN VERSION 1.3.4
-------------------------

USER-VISIBLE CHANGES

	- Updated tests, examples for merge_samples()

	- Updated some dependency min versions

	- First 2013 commit

CHANGES IN VERSION 1.3.3
-------------------------

USER-VISIBLE CHANGES

	- updates to import_qiime()

	- modular building of taxonomy table in import_qiime() and import_biom()

CHANGES IN VERSION 1.3.2
-------------------------

USER-VISIBLE CHANGES

	- import_biom() fixes.

	- More robust data handling for taxonomy table

	- Flexibility: Can take custom parsing function for taxonomy vectors

	- tests added for new parsing functions
		parse_taxonomy_default
		parse_taxonomy_greengenes

CHANGES IN VERSION 1.3.1
-------------------------

USER-VISIBLE CHANGES

	- New function: plot_bar() that is simpler more reliable than plot_taxa_bar.

	- plot_taxa_bar now deprecated.
	
	- labeled deprecated in title doc

	- replaced examples in vignette with plot_bar examples

CHANGES IN VERSION 1.3.0
-------------------------

USER-VISIBLE CHANGES

	- Level up github devel version number to reflect devel order/status relative to latest BioC release


CHANGES IN VERSION 1.1.58
-------------------------

USER-VISIBLE CHANGES

	- Fixed a bug in import_qiime in which import fails if there are any empty taxonomy 
		string fields in a file that otherwise has some taxonomic assignments. 
		Now the taxonomy entries for that OTU (row in the taxonomy table) are left all NA_character_ by default.

CHANGES IN VERSION 1.1.57
-------------------------

USER-VISIBLE CHANGES

	- Added automatic removal of single and double quotes from phylogenetic tree tip names provided to the phyloseq-constructor.
		This should help avoid problems
	 	importing data that includes a tree, for the cases where the taxa/OTU names don't match because of these extra quotation marks. Added directly into the 
		phyloseq() constructor, so that it doesn't matter how/where the tree was imported/add.

	- Removal of quotes is only initiated when OTU/taxa names fail to match AT ALL
		(intersection is length zero) between component taxa names. 

	- This feature needs to be added to unit tests as well.

CHANGES IN VERSION 1.1.55
-------------------------

USER-VISIBLE CHANGES

	- Added "title" argument to plot_scree() and plot_ordination(…, type="scree"), for consistency.

CHANGES IN VERSION 1.1.54
-------------------------

USER-VISIBLE CHANGES

	- Changed "species" label in different plot_ordination() graphics to "taxa"

	- Fixed an issue with a default parameter in a related internal function
		(changed "samples" to "sites" for vegan compatibility).

CHANGES IN VERSION 1.1.53
-------------------------

USER-VISIBLE CHANGES

	- Fixed additional title issues in plot_network and plot_richness

CHANGES IN VERSION 1.1.52
-------------------------

USER-VISIBLE CHANGES

	- Added plot_scree() function for making eigenvalue "scree" plots in ggplot2

	- Added corresponding type="scree" option to plot_ordination, for convenience.

CHANGES IN VERSION 1.1.51
-------------------------

USER-VISIBLE CHANGES

	- Returned to "Imports:" dependency for ggplot2 following a ggplot2 bug fix

CHANGES IN VERSION 1.1.50
-------------------------

USER-VISIBLE CHANGES

	- Fixed several compatibility issues to support latest version of ggplot2 (0.9.2).

	- Also changes plot_richness_estimates() to plot_richness().

CHANGES IN VERSION 1.1.45
-------------------------

USER-VISIBLE CHANGES

	- Backward compatibility for import_qiime_sampleData,
	  now superseded by import_qiime_sample_data

	- Added a functioning example based on the GlobalPatterns
	  example sample-map file included in the package extdata.

CHANGES IN VERSION 1.1.44
-------------------------

USER-VISIBLE CHANGES

	- Fixed minor bug in tax_glom function.
	  Thanks to Katie Shelef for the bug report. Bug only affected tax_glom behavior when the
	  right-most rank was specified as the position for merging.

CHANGES IN VERSION 1.1.43
-------------------------

USER-VISIBLE CHANGES

	- fixed distance() issue from species/taxa replacement for type argument.

CHANGES IN VERSION 1.1.42
-------------------------

USER-VISIBLE CHANGES

	- fixed make_network/plot_network issue from species/taxa replacement for type argument.

CHANGES IN VERSION 1.1.41
-------------------------

USER-VISIBLE CHANGES

	- Fixed documentation for `prune_taxa` and `prune_samples`

	- Updated `prune_samples` method to allow for logical vectors.

	- Fixed `prune_taxa` so that it properly fails with a message if the taxa argument is a logical of wrong length.
	   There was some potential (and no warning) for unpredictable vector-recycling
	   with short vectors in the old implementation.

CHANGES IN VERSION 1.1.40
-------------------------

USER-VISIBLE CHANGES

	- Huge Update and Renaming Event.

	- Made all functions use an *underscore* for English word delimiter, if they were using an abbreviation. 

	- Replaced "species" in all function names with "taxa". 

	- These changes are all backward compatible, for now, so your old code should work. 
		Let me know if it doesn't and I will quickly make the adjustment. This will remain true through the next official release,
		but functional references to "species" will not be supported afterward,
		except in the occasions where you actually mean taxonomic species, like `tax_glom(x, "species")`.

CHANGES IN VERSION 1.1.33
-------------------------

USER-VISIBLE CHANGES

	- Revise taxglom() such that it handles phyloseq and taxonomyTable classes,
		throws warning otherwise. It should not take a manually-produced character
		vector, as this is roughly equivalent to functionality supported in other method,
		especially prune_species()/merge_species().

	- Also added unit-tests and executable examples for taxglom().
		Got rid of taxglom.internal, incorporated directly into taxglom().
		taxglom() is no longer an S4-method, and 
		doesn't need to be now that the character-vector argument option is omitted,
		with S4-class handling delegated to merge_species().
		Updated "taxTab<-" to be S4 assignment, clearer handling of taxonomy Table assignments,
		especially useful for taxglom.

CHANGES IN VERSION 1.1.29
-------------------------

USER-VISIBLE CHANGES

	- Add unit tests and example files for import_biom (as well as import("biom",...) ).

CHANGES IN VERSION 1.1.28
-------------------------

USER-VISIBLE CHANGES

	- Added rarefy_even_depth() function for random subsampling of microbiome samples to the same number of reads. 
		Default uses the minimum total reads among the samples in the dataset. This is based on the core "sample" function, 
		which can have its random number generator fixed by set.seed for reproducibility.

CHANGES IN VERSION 1.1.27
-------------------------

USER-VISIBLE CHANGES

	- Fix bug in plot_ordination that caused an error rather than produce unannotated plots when sampleData absent in the input.

CHANGES IN VERSION 1.1.23-26
-------------------------

USER-VISIBLE CHANGES

	- Added unit tests and bugfixes

CHANGES IN VERSION 1.1.19-22
-------------------------

USER-VISIBLE CHANGES

	- Improving import_qiime() importer to handle large datasets,
		like the HMPv35 dataset, for example, while also providing useful status messages
		during non-trivial imports that might take 10 minutes or more to complete.

CHANGES IN VERSION 1.1.18
-------------------------

USER-VISIBLE CHANGES

	- Added replicate labels as a "Sample" factor in the soilrep dataset.

CHANGES IN VERSION 1.1.17
-------------------------

USER-VISIBLE CHANGES

	- Fix possible bug that results from the latest version (0.6+) of igraph not being backward compatible. 
		A stable igraph0 package is available on CRAN as a stop-gap, and so all igraph dependencies were migrated
		to "igraph0" until the phyloseq-source can be updated to match the igraph latest.

CHANGES IN VERSION 1.1.15
-------------------------

USER-VISIBLE CHANGES

	- plot_heatmap: Added default (but adjustable) threshold to omit taxa/sample labels

CHANGES IN VERSION 1.1.14
-------------------------

USER-VISIBLE CHANGES

	- Update import_qiime() function to import latest non-BIOM qiime output files.
		Also added check for presence of taxonomy information (consensus lineage).

CHANGES IN VERSION 1.1.10
-------------------------

USER-VISIBLE CHANGES

	- Add plot_heatmap() function, for easy flexible heat maps built with ggplot2

CHANGES IN VERSION 1.1.8-9
-------------------------

USER-VISIBLE CHANGES

	- Fix bug for some variants of new BIOM format

	- Add import_RDP_otu() import function for new RDP pipeline export format

CHANGES IN VERSION 1.1.7
-------------------------

USER-VISIBLE CHANGES

	- Removed the old plot_tree_phyloseq() function, in favor of the new ggplot2-based plot_tree()

	- Uncommented / tested formal examples in documentation of plot-functions

	- Updated variable names and doc for the plot_taxa_bar() function

CHANGES IN VERSION 1.1.6
-------------------------

USER-VISIBLE CHANGES

	- Update vignette with plot_tree() example, replacing the 
	   old base-graphics function, plot_tree_phyloseq().

	- Fix bug in legend for trees with size mapped to abundance

CHANGES IN VERSION 1.1.5
-------------------------

USER-VISIBLE CHANGES

	- Add initial version of tree_plot(), built with ggplot2

	- Adds several internal functions borrowed from devel version of ggphylo

CHANGES IN VERSION 1.1.4
-------------------------

USER-VISIBLE CHANGES

	- Add errorIfNULL option to auxiliary accessors
	  (e.g. sample.variables(), rank.names())

CHANGES IN VERSION 1.1.1-3
-------------------------

USER-VISIBLE CHANGES

	- R version updated to match Bioconductor, R-2.15.0+

	- ape-package version updated to 3.0+

	- ape-package now import dependency

	- ggplot2-package version updated to 0.9.0+

	- ggplot2-package now import dependency

CHANGES IN VERSION 0.99.48
-------------------------

USER-VISIBLE CHANGES

	- Updated README.md

CHANGES IN VERSION 0.99.47
-------------------------

USER-VISIBLE CHANGES

	- Add support for ordinate() to take dist-object instead of distance-method string.

	- Update the documentation for ordinate() to reflect change.

	- Updated README.md to describe new tools, distance() and ordinate()

	- Update JSD documentation.

CHANGES IN VERSION 0.99.46
-------------------------

USER-VISIBLE CHANGES

	- Added support and documentation for Jensen-Shannon Divergence to distance().

	- Some updates to distance() function and its documentation.

CHANGES IN VERSION 0.99.45
-------------------------

USER-VISIBLE CHANGES

	- Completely remove vegdist documentation from phyloseq by omitting all roxygen2
	  headers except for #' keywords internal

	-  This finally fixes it, without build warnings/errors, once and for all.

CHANGES IN VERSION 0.99.44
-------------------------

USER-VISIBLE CHANGES

	- Make the phyloseq::vegdist() wrapper an internal function. Documentation updated as well.
	  This is a solution to Issue 87
	  https://github.com/joey711/phyloseq/issues/87

	- Remove rda.phyloseq and cca.phyloseq from exported methods.
	  Documentation had already been removed when these were first attempted to be converted
	  to internal methods in CHANGES IN VERSION 0.99.42

	- Modify make_sample_network to use the new distance() function, and be able to pass on
	  additional parameters to distance().

	- Re-order arguments to make_sample_network to better represent the stability of defaults.

	- Removed redundant parameters from make_sample_network(). Transformations to abundance
	  tables should be performed upstream using phyloseq tools, not embedded in this function.

	- Modify vignettes to reflect these changes.

	- Rebuild vignette.

	- Update import() documentation to reflect support for BIOM format, import_biom() function.

CHANGES IN VERSION 0.99.43
-------------------------

USER-VISIBLE CHANGES

	- Revise component assignment operators, e.g. "sampleData(physeq)<-" to coerce/access
	  from more diverse objects based on context. Documentation for these operators updated.
	  This is a more general solution to Issue 68
	  https://github.com/joey711/phyloseq/issues/68

CHANGES IN VERSION 0.99.42
-------------------------

USER-VISIBLE CHANGES

	- purge rda.phyloseq and cca.phyloseq from documentation, vignettes. Internal functions.

	- analysis vignette revisions

CHANGES IN VERSION 0.99.41
-------------------------

USER-VISIBLE CHANGES

	- Added ordinate() function, general ordination wrapper.

CHANGES IN VERSION 0.99.40
-------------------------

USER-VISIBLE CHANGES

	- Fixed case issues with source filenames. 
	  Required multiple commits, break in versioning for source files that had improper letter case (e.g. ".r")

CHANGES IN VERSION 0.99.37 - 0.99.39
-------------------------

USER-VISIBLE CHANGES

	- Vignette updates.

CHANGES IN VERSION 0.99.36
-------------------------

USER-VISIBLE CHANGES

	- Added general distance calculation wrapper, distance()

	- Consolidated it with unifrac.R code in a new "distance-methods.R" source file.

CHANGES IN VERSION 0.99.35
-------------------------

USER-VISIBLE CHANGES

	- Added tool to retain user-defined subset of points from an ordination, subset_ord_plot

	- Updates to vignette

	- Remove a poorly-documented, unpublished example dataset, ex1 -> and all references to it in documentation

CHANGES IN VERSION 0.99.34
-------------------------

USER-VISIBLE CHANGES

	- Updates to vignette

CHANGES IN VERSION 0.99.33
-------------------------

USER-VISIBLE CHANGES

	- Allow color specification for "biplot" type in plot_ordination()

	- bug fix for certain combinations of biplot options.

CHANGES IN VERSION 0.99.32
-------------------------

USER-VISIBLE CHANGES

	- Remove plot_ordination_biplot() from phyloseq -> replaced by: plot_ordination()

	- pipes "|->" also removed from vignette.

	- Remove calcplot(). -> Will be replaced by pipeline_() methods

	- plot_ordination() shown in vignette for "species" plot type.

	- Fix - Allow flexible axis labels for plot_ordination()

CHANGES IN VERSION 0.99.31
-------------------------

USER-VISIBLE CHANGES

	- Aesthetic fixes in plot_ordination()

	- Remove plot_ordination_samples() -> redundant, covered by plot_ordination().

CHANGES IN VERSION 0.99.30
-------------------------

USER-VISIBLE CHANGES

	- Added plot_ordination -> general ordination plotting function

CHANGES IN VERSION 0.99.29
-------------------------

USER-VISIBLE CHANGES

	- Added first-draft of analysis vignette to package

	- Total package-space and build/check times tested

CHANGES IN VERSION 0.99.28
-------------------------

USER-VISIBLE CHANGES

	- Fixed bug when specifying alternative axes in plot_ordination_samples()

CHANGES IN VERSION 0.99.27
-------------------------

USER-VISIBLE CHANGES

	- Added DPCoA() function for Double Principle Coordinate Analysis, relies heavily on ade4.

	- Added ade4 dependency. Some masking, but no errors apparent.

	- Added dpcoa extension for scores()

	- minor bugfix in plot_ordination_biplot().

CHANGES IN VERSION 0.99.26
-------------------------

USER-VISIBLE CHANGES

	- Add plot_ordination_samples() for convenient ordination plotting

	- Renamed plot_ordination_phyloseq to more precise, plot_ordination_biplot()

	- Added extension to vegan::scores for ape:pcoa results, scores.pcoa()

CHANGES IN VERSION 0.99.25
-------------------------

USER-VISIBLE CHANGES

	- Fix build warning from duplicate import in namespace

	- Update README.md

CHANGES IN VERSION 0.99.24
-------------------------

USER-VISIBLE CHANGES

	- Advanced network/graph plotting/visualization wrappers: make_sample_network(), plot_sample_network()

	- Advanced alpha diversity wrappers: plot_richness_estimates(), estimate_richness()

	- Added taxafilter() function for even more convenient filtering of species/taxa

	- Added reshape dependency for explicit use of melt() function.

CHANGES IN VERSION 0.99.23
-------------------------

USER-VISIBLE CHANGES

	- Added a rooted tree to "GlobalPatterns" dataset

	- Allow multi-class tests with mt()

CHANGES IN VERSION 0.99.20
-------------------------

USER-VISIBLE CHANGES

	- Added "GlobalPatterns" dataset, and some other minor improvements

	- added "GlobalPatterns" dataset, with doc and some analysis
	  examples. More examples will be added to the vignette.

	- add getVariable accessor function, for streamlining access
	  to values/vectors/factors/etc of the variates contained in
	  the sampleData component

	- revise documentation about parallelization of import_biom()

	- revise documentation for enterotype dataset

CHANGES IN VERSION 0.99.19
-------------------------

USER-VISIBLE CHANGES

	- fixed a bug in general import() function in which it properly processed import command, but then failed to return result.

CHANGES IN VERSION 0.99.18
-------------------------

USER-VISIBLE CHANGES

	- Added import_biom() function to import BIOM format OTU-clustered data / metadata

	- Added (direct) dependency for plyr, as well as RJSONIO 

CHANGES IN VERSION 0.4.2-7
-------------------------

USER-VISIBLE CHANGES

	- Improvements to import_mothur() via import_mothur_otulist().

	- merge_samples() function added, in preparation for hypergeometric (fisher.test) test wrapper.

	- Fixed bug in merge_phyloseq() for certain combinations of objects. 

	- Various other fixes and improvements.

CHANGES IN VERSION 0.4.1
-------------------------

USER-VISIBLE CHANGES

	- First official submission to Bioconductor

	- Includes many build-fixes, bug-fixes

	- Final tweaks to conform to Bioconductor guidelines

CHANGES IN VERSION 0.3
-------------------------

USER-VISIBLE CHANGES

	- Added Importers for mothur, RDP-pipeline, and PyroTagger

	- Lots of new plotting and analysis support

	- Parallelized UniFrac calculations using foreach package

	- Some improvements to the class inheritance structure to simplify method extension and future development.

	- Function-level documentation

	- Vignette-level documentation

	- Package dependencies achieved via import for all packages with a namespace. Depends (full load) otherwise.

CHANGES IN VERSION 0.2.4
-------------------------

USER-VISIBLE CHANGES

	- Added ordination and plotting pipeline, calcplot() and plot.ordination.phyloseq()

	- All trees converted to phylo4 by default. Support for phyla achieved by coercion to phylo4.

CHANGES IN VERSION 0.2
-------------------------

USER-VISIBLE CHANGES

	- Modifications for proper build, and bug tests.

CHANGES IN VERSION 0.1
-------------------------

USER-VISIBLE CHANGES

	- basic data structure in place.

	- some support for phylo4 objects

	- import_qiime(): A Qiime input wrapper

